/*****************************************************************/
/*      reportFailure.c                                          */
/*      Henri Casanova                                           */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include "core.h"
#include "client.h"
#include "client2proxy.h"

#ifndef WIN32
#include <unistd.h>
#endif /* UNIX */

#include <signal.h>
#include <time.h>

/*
 *  reportFailure()
 * 
 * This function is to be called at the client level when an error
 * has been detected. It is expected that the proxy can handle most
 * of the error cases. However, some errors can only be detected by the
 * client (e.g. the server dies while sending output back).
 */
void reportFailure(NS_IPaddr_type IPaddr, char *nickname, 
                   int ID, int error_type)
{
  CP_reportFailure(IPaddr, nickname, ID, error_type);
}
